# MOVEMENT CHECKS NEED horizwrapPING SUPPORT!

import pygame, pygame.image
import pygame.font
#Err pygame.font could fail on some systems
from pygame.locals import *

import os

from const import *
from map import Map

digfromlist = [FLOOR, PERMFLOOR, LADDER, POLE]
nodigunderlist = [LADDER, POLE, SWITCH, SPIKES]

pygame.init()
pygame.display.set_caption("PyRunner " + VERSION)
#bestdepth = pygame.display.mode_ok((SCREENWIDTH, SCREENHEIGHT), FULLSCREEN, 16)
screen = pygame.display.set_mode((SCREENWIDTH, SCREENHEIGHT), FULLSCREEN, 16)
pygame.mouse.set_visible(0)

gamemap = Map("map.dat")

mapdatafiles = ("empty.bmp", "floor.bmp", "solid.bmp", "ladder.bmp",
                "pole.bmp", "vpole.bmp", "gold.bmp", "gatel.bmp",
                "gater.bmp", "switch.bmp", "spikes.bmp", "exit.bmp")

runnerfiles = ("runner.bmp",)

mapsprites = []
for filename in mapdatafiles:
    surf = pygame.image.load(os.path.join(gamemap.artwork, filename))
    #Err
    surf.set_colorkey(TRANSTUPLE, RLEACCEL)
    mapsprites.append(surf.convert())

runnersprites = []
for filename in runnerfiles:
    surf = pygame.image.load(os.path.join(gamemap.artwork, filename))
    #Err
    surf.set_colorkey(TRANSTUPLE, RLEACCEL)
    runnersprites.append(surf.convert())

posy = gamemap.playerstart[0]
posx = gamemap.playerstart[1]
falling = 0
score = 0
diggedfloors = []
currenthint = 0
hintfont = pygame.font.Font(None, 20)

def canmoveto(y, x, dir = None):
    if (y, x) in gamemap.false:
        return 1
    sq = gamemap.data[y][x]
    if sq == FLOOR or sq == PERMFLOOR:
        return 0
    if dir == 0:
        if sq == GATERIGHT:
            return 0
    if dir == 1:
        if sq == GATELEFT:
            return 0
    return 1

def doafter():
    if gamemap.stage != gamemap.numstages:
        if gamemap.flipgatesatend and\
           gamemap.stage == gamemap.numstages - 1:
            doswitch()
        for item in gamemap.after[gamemap.stage]:
            gamemap.data[item[0]][item[1]] = item[2]
            if item[2] == TREASURE:
                gamemap.treasureleft += 1
            if item[2] == GATELEFT or item[2] == GATERIGHT:
                gamemap.gates.append((item[0], item[1]))
            if item[2] == EXITPOINT:
                gamemap.exits.append((item[0], item[1]))
            # special symbols (and others?)
        gamemap.stage += 1
    drawmap()

def credittreasure():
    global score
    if gamemap.data[posy][posx] == TREASURE and\
       (posy, posx) not in gamemap.false:
        gamemap.data[posy][posx] = EMPTY
        score += TREASUREVALUE
        drawmap(posy, posx, posy + 1, posx + 1)
        gamemap.treasureleft -= 1
        if gamemap.treasureleft == 0:
            doafter()

def canclimb(y, x):
    if gamemap.data[y][x] == LADDER and (y, x) not in gamemap.false:
        return 1
    return 0

def willfall():
    global falling
    falling = 0
    if posy < MAPHEIGHT - 1:
        if gamemap.data[posy][posx] == EMPTY or\
           (posy, posx) in gamemap.false:
            sq = gamemap.data[posy + 1][posx]
            if (sq != FLOOR and sq != PERMFLOOR and\
               sq != LADDER and sq != POLE) or\
               (posy + 1, posx) in gamemap.false:
                falling = 1

def moveleft():
    global posx
    if posx == 0:
        if gamemap.horizwrap:
            posx = MAPWIDTH - 1
        return
    if canmoveto(posy, posx - 1, 0):
        posx -= 1

def moveright():
    global posx
    if posx == MAPWIDTH - 1:
        if gamemap.horizwrap:
            posx = 0
        return
    if canmoveto(posy, posx + 1, 1):
        posx += 1

def moveup():
    global posy
    if posy == 0:
        return
    if canclimb(posy, posx):
        if canmoveto(posy - 1, posx):
            posy -= 1

def movedown():
    global posy, falling
    if posy == MAPHEIGHT - 1:
        falling = 0
        return
    if canmoveto(posy + 1, posx):
        posy += 1

def doswitch():
    for gate in gamemap.gates:
        assert gamemap.data[gate[0]][gate[1]] in (GATELEFT, GATERIGHT)
        if gamemap.data[gate[0]][gate[1]] == GATELEFT:
            gamemap.data[gate[0]][gate[1]] = GATERIGHT
        else:
            gamemap.data[gate[0]][gate[1]] = GATELEFT
        drawmap(gate[0], gate[1], gate[0] + 1, gate[1] + 1)

def digleft():
    if posx == 0:
        return
    if gamemap.data[posy][posx - 1] == SWITCH and\
       (posy, posx - 1) not in gamemap.false:
        doswitch()
        return
    if posy == MAPHEIGHT - 1:
        return
    if gamemap.data[posy + 1][posx] not in digfromlist:
        return
    if canmoveto(posy, posx - 1):
        if (gamemap.data[posy + 1][posx - 1] == FLOOR and\
           (posy + 1, posx - 1) not in gamemap.false and\
           gamemap.data[posy][posx - 1] not in nodigunderlist) or\
           (posy, posx - 1) in gamemap.false:
            gamemap.data[posy + 1][posx - 1] = EMPTY
            diggedfloors.append((posy + 1, posx - 1, pygame.time.get_ticks()))
            drawmap(posy + 1, posx - 1, posy + 2, posx)

def digright():
    if posx == MAPWIDTH - 1:
        return
    if gamemap.data[posy][posx + 1] == SWITCH and\
       (posy, posx + 1) not in gamemap.false:
        doswitch()
        return
    if posy == MAPHEIGHT - 1:
        return
    if gamemap.data[posy + 1][posx] not in digfromlist:
        return
    if canmoveto(posy, posx + 1):
        if (gamemap.data[posy + 1][posx + 1] == FLOOR and\
           (posy + 1, posx + 1) not in gamemap.false and\
           gamemap.data[posy][posx + 1] not in nodigunderlist) or\
           (posy, posx + 1) in gamemap.false:
            gamemap.data[posy + 1][posx + 1] = EMPTY
            diggedfloors.append((posy + 1, posx + 1, pygame.time.get_ticks()))
            drawmap(posy + 1, posx + 1, posy + 2, posx + 2)

def drawmap(y1 = 0, x1 = 0, y2 = MAPHEIGHT, x2 = MAPWIDTH):
    if x1 < 0: x1 = 0
    if y1 < 0: y1 = 0
    if x2 > MAPWIDTH: x2 = MAPWIDTH
    if y2 > MAPHEIGHT: y2 = MAPHEIGHT
    if x1 >= x2 or y1 >= y2: return;

    screen.fill((0, 0, 0),
                (x1 * SPRITEWIDTH, y1 * SPRITEHEIGHT,
                 (x2 - x1) * SPRITEWIDTH, (y2 - y1) * SPRITEHEIGHT))
    y = y1 * SPRITEHEIGHT
    for i in range(y1, y2):
        x = x1 * SPRITEWIDTH
        for j in range(x1, x2):
            screen.blit(mapsprites[gamemap.data[i][j]], (x, y))
            x += SPRITEWIDTH
        y += SPRITEHEIGHT

def updateframe():
    screen.blit(runnersprites[0], (posx * SPRITEWIDTH, posy * SPRITEHEIGHT))
    pygame.display.flip()

def checkdeath():
    if (posy, posx) in gamemap.false:
        return 0
    sq = gamemap.data[posy][posx]
    if sq == FLOOR or sq == SPIKES:
        return 1
    # Do enemy collisions
    return 0

def checkexit():
    if gamemap.stage != gamemap.numstages:
        return
    for exitsq in gamemap.exits:
        if exitsq[0] == posy and exitsq[1] == posx:
            return (posy, posx)
    if gamemap.exitattop and posy == 0:
        return (-1, -1)
    return None

def checktimedevents():
    # To be 100% safe we should really adjust for get_ticks()
    # horizwraparound if it occurs.
    curtime = pygame.time.get_ticks()
    for floor in diggedfloors:
        if curtime >= floor[2] + REGENDELAY:
            gamemap.data[floor[0]][floor[1]] = FLOOR
            drawmap(floor[0], floor[1], floor[0] + 1, floor[1] + 1)
            diggedfloors.remove(floor)

def showhint():
    global currenthint
    if len(gamemap.hints) == 0:
        return
    screen.fill((0, 0, 0),
                (0, VIEWHEIGHT,
                 VIEWWIDTH, SCREENHEIGHT - VIEWHEIGHT))
    hintsurf = hintfont.render(gamemap.hints[currenthint],
                               1, (255, 255, 255))
    screen.blit(hintsurf, (0, VIEWHEIGHT))
    del hintsurf
    currenthint += 1
    if currenthint == len(gamemap.hints):
        currenthint = 0

drawmap()
pygame.time.delay(2000) # Avoids game starting before screen ready.
willfall()
credittreasure()
while 1:
    event = pygame.event.poll()
    if event.type == QUIT:
        break
    if event.type == ACTIVEEVENT:
        print event
    keystate = pygame.key.get_pressed()
    if keystate[K_ESCAPE]: break;

    drawmap(posy, posx, posy + 1, posx + 1)
    if not falling:
        if keystate[K_LEFT]: moveleft()
        if keystate[K_RIGHT]: moveright()
        if keystate[K_UP]: moveup()
        if keystate[K_DOWN]: movedown()
        if keystate[K_LCTRL]: digleft()
        if keystate[K_LALT]: digright()
        if keystate[K_h]: showhint()
    else:
        movedown()
    willfall()
    credittreasure()
    if checkdeath():
        break
    if checkexit():
        break
    checktimedevents()
    updateframe()
    pygame.time.delay(100)

updateframe()
